/*
   Copyright (C) 1999 Marek Michalkiewicz <marekm@linux.org.pl>

   Permission to use, copy, modify, and distribute this software and
   its documentation for any purpose and without fee is hereby granted,
   without any conditions or restrictions.  This software is provided
   "as is" without express or implied warranty.
 */

#include <runtime/lib.h>

signed char
strncmp(const char *s1, const char *s2, mem_size_t n)
{
	if (n) {
		register signed char ret;
		register char tmp;
		do {
			ret = *s1++ - (tmp = *s2++);
		} while ((ret == 0) && (tmp != 0) && --n);
		return ret;
	}
	return 0;
}
